module Lifen
  class Configuration
    attr_accessor :site, :application_access_token, :proxy_url, :expiration_margin, :token_refresh_lock

    def initialize(args)
       args.each do |k,v|
        instance_variable_set("@#{k}", v) unless v.nil?
      end

      @token_refresh_lock = Mutex.new
    end

    def site=(url)
      if !/(.*)\/$/.match(url)
        raise Lifen::Error, "Invalid 'site' provided in configuration: '#{url}', a trailing slash is missing"
      end

      @site = url
    end
  end

  def self.configuration
    @configuration ||= Configuration.new(expiration_margin: 0)
  end

  def self.configure
    yield(configuration) if block_given?
  end
end