module Lifen
  class Flows < Base

    attribute :user, Lifen::User
    attribute :elements, Array[Lifen::Flow], default: []

    def all
      json = client.get("central/api/chats")

      json["_embedded"]["flows"].each do |element|
        flow = Flow.new(element)
        flow.user = user

        elements << flow
      end

      elements
    end

    private

      def client
        @client ||= user.client
      end

  end
end