module Lifen
  class Message < Base

    attribute :uuid, String
    attribute :content, String
    attribute :type, String, default: "regular"
    attribute :flow, Lifen::Flow
    attribute :sent_at, DateTime


    def create
      json = client.post("central/api/chats/#{flow.uuid}/messages", {content: content, type: type})

      json["sent_at"] = json["sentDate"]

      message = self.class.new(json)

      self.flow = flow
      self.uuid = message.uuid
      self.content = message.content
      self.type = message.type
      self.sent_at = message.sent_at

      self
    end

    private

      def client
        @client ||= flow.user.client
      end

  end
end