module Lifen
  class Settings

    include Virtus.model(finalize: false)

    attribute :user, "Lifen::User"

    attribute :email_notifications, Boolean
    attribute :push_notifications, Boolean

    def reload
      json = client.get("central/api/settings")

      load_from_json(json)

      self
    end

    alias refresh reload

    def save
      params = {"emailNotifications" => email_notifications, "pushNotifications" => push_notifications}

      json = client.post("central/api/settings", params)

      load_from_json(json)

      self
    end

    private

      def client
        @client ||= user.client
      end

      def load_from_json(json)
        self.email_notifications    = json["emailNotifications"]
        self.push_notifications     = json["pushNotifications"]
      end

  end
end